Description

The ability to access DUNE services from the Root command is gone. Presumably due to the switch to Root 6 or (more likely)
changes in art. It is still possible to use ArtServiceHelper to load services but they cannot be accessed because the ServiceHandle
header cannot be parsed.

I would like to make it possible for services to be accessed from the Root command line.

History

#1-01/17/2017 11:15 AM - David Adams
- Status changed from New to Assigned

- Assignee set to David Adams

| have added ArtServicePointer<T> which returns the pointer to the service of (typically interface) type T. It uses ServiceHandle.

| have also created DuneServiceAccess which provides template specializations of ArtServicePointer for the service types we wish to make
accessible from root. The implementations for these are put in a library that is loaded in Root. See the header

dunetpc/dune/DuneServiceAccess/DuneServiceAccess.h

for instructions on how to use these to access services in Root.

#2 - 01/17/2017 11:30 AM - David Adams

The service headers are modified to hide the service macro header and declaration from Root. E.g.

#ifndef _ CLING__

#include "art/Framework/Services/Registry/ServiceMacros.h"
DECLARE_ART_SERVICE_INTERFACE (AdcDeconvolutionService, LEGACY)
#endif

#3 - 01/17/2017 11:33 AM - David Adams

The following service interfaces are now accessible in Root:

AdcChannelNoiseRemovalService
AdcDeconvolutionService
AdcNoiseRemovalService
AdcSuppressService
ChannelGroupService
PedestalEvaluationService

I think the first is a duplicate of the third and should be removed.

#4 - 01/17/2017 11:35 AM - David Adams
The preceding are now pushed to dunetpc in tag 1bee1889a576eb052fd5dc069793ce43c3467267.

#5 - 01/17/2017 11:44 AM - David Adams

| see that AdcChannelNoiseRemovalService removes noise from one channel while AdcNoiseRemovalService removes noise from multiple channels.
| retain both. At present only the latter is used in reco.
#6 - 01/17/2017 12:28 PM - David Adams

| have modified ArtServiceHelper so it can be instantiated and loaded from a file in a single command, e.g.

ArtServiceHelper& ash = ArtServiceHelper::instance ("standard_reco_dune35tdata.fcl");
Committed to dunetpc tag 29c3587fd78f0b514664b682d76ada359446559f.

#7 - 01/17/2017 12:56 PM - David Adams

Add two more services:

AdcChannelDataCopyService
AdcCompressService

Modify ArtServicePointer to make direct use of ServiceManager instead of ServiceHandle so it can return null instead of throwing an exception when
a requested service has not been loaded.

Committed to dunetpc tag 3e3931c92b2dbfa604eb1ee1e04eee1f02356bf7.

#8 - 01/17/2017 01:48 PM - David Adams

| add more services and modify ArtServicePointer to return nullptr and issue message instead of throwing an exception if the service manage is not
present.

Committed to dunetpc tag 61ab34308caf0dfd5ab41cf488559067f61e258¢.

#9 - 01/18/2017 09:21 AM - David Adams

| was getting crashes on Root exit from services that use TFileService. This is an old problem: https://cdcvs.fnal.gov/redmine/issues/10618 that can
be resolved by calling

ArtServiceHelper::close();
before exiting root.

| tried adding an automatic call to close (see ArtServiceHelperCloser in ArtServiceHelper.cxx) but it is called too late. So the following should be
included in rootlogoff.C to avoid the crash:

ArtServiceHelper::close();

#10 - 01/18/2017 09:47 AM - David Adams

| have added specializations for all services in Dunelnterface to DuneServiceAccess.

| have renamed the method for loading all services for a file. New syntax is:

ArtServiceHelper::load("standard_reco_dune35tdata.fcl");

The service helper reference may be obtained from this call or from a call to ArtServiceHelper::instance().

#11 - 01/18/2017 09:52 AM - David Adams

- Status changed from Assigned to Closed

| have committed the preceding to dunetpc eeOb18e1a9ca416f171cb4cbfdad7d2cb1f4a667.
All dunetpc tests pass.

| close this report.
